/*********************************/
/*	COMP 250	
 * 	Assigment 3
 * 
 * 	By: 
 * 	Simon Foucher
 * 	260 223 197
 * 
/*********************************/


package Question1;

public class QueueFromStack {
	  /* Instance Fields */
	private StackSLL Qstack;
	
	  /* Constructor */
	public QueueFromStack(){
		Qstack = new StackSLL();
	}
	
	
	/*	Methods	*/
	
	// The stack Q will be kept "reversed" so that the overhead of reversing it
	// is only done once when inserting in the Q (instead of both when peeking and deQing)
	// Objects popped from the Q will be popped from the stack
	
	public void enqueue(Object o){
		// Create an object to serve as a temporary stack to hold rata
		StackSLL tempStack  = new StackSLL();

		// Get to the bottom of the Qstack
		while(Qstack.peek() != null)
			tempStack.push(Qstack.pop());

		// Push the new guy at the back of the Q (bottom of the stack)
		Qstack.push(o);
		
		// Then reload the stack with the Q
		while(tempStack.peek() != null)
			Qstack.push(tempStack.pop());
	}

	// Since the newest guy is at the bottom of the stack, oldest is at top
	public Object dequeue(){
			return Qstack.pop();
	}
	
	// Since the newest guy is at the bottom of the stack, oldest is at top
	public Object peek(){
		return Qstack.peek();
	}

	public boolean isEmpty(){
		return Qstack.isEmpty();
	}

	
	/*
	  // To test
	  public static void main(String[] args){
		  QueueFromStack q = new QueueFromStack();
		  q.enqueue("Testing");
		  q.enqueue("ONE");
		  q.enqueue("TWO");
		  q.enqueue(new Integer(69));
		  System.out.println(q.peek());
		  System.out.println(q.peek());
		  System.out.println(q.peek());
		  System.out.println(q.dequeue());
		  q.enqueue("TREE");
		  System.out.println(q.dequeue());
		  q.enqueue("FOUR");
		  System.out.println(q.dequeue());
		  System.out.println(q.dequeue());
		  System.out.println(q.dequeue());
		  System.out.println(q.dequeue());
		  System.out.println(q.dequeue());
		  System.out.println(q.dequeue());

	  }
	*/
	
}
