/*********************************/
/*	COMP 250	
 * 	Assigment 3
 * 
 * 	By: 
 * 	Simon Foucher
 * 	260 223 197
 * 
/*********************************/

package Question3;

	/*
	 * Qstack
	 * 
	 * Modified from the class QueueSLL from Question 2
	 * 
	 * Modifications: 
	 * 		- Link list of integers instead of general objects
	 * 		- peek() returns a peek at the last entered element (like looking at the top of a stack
	 * 		
	 * 
	 * Additions
	 * 		- Variable Qsize keeps track of the size of the linked list
	 * 		- int sizeIs(): returns the size of the list
	 * 		- int deStack(): pops the last element entered in the list (equivalent to a stack.pop)
	 */

public class Qstack {

	  /* instance fields */
	  int value;
	  Qstack front, back, next;
	  int Qsize = 0;


	  /* Constructors */
	  public Qstack(){
		  front = back = next = null;
	  }
	  
	  public Qstack(int o){
		  value = o;
		  next = null;
	  }
	
	  
	  /* Methods	*/
	  
		public void enqueue(int o){
			Qsize++;
			// If the Q is empty, make it with a single element
	        if(isEmpty( ))    
	            back = front = new Qstack(o);
	        // Otherwise, insert new element at the back of the Q
	        else                // Regular case
	            back = back.next = new Qstack(o);
		}
		
		
		public int deStack(){
	        if(isEmpty( ))
	            return 0;
	        
	        Qsize--;
        
			// Create a new Q with the new element
			Qstack tempQ = new Qstack();
			int returnElement = 0;
		  
			// Reverse the order of the Q into a temp Q
			  while(front.next != null)
				  tempQ.enqueue(dequeue());
			  
			 returnElement = dequeue();
			 

			  // The reverse the order a second time. 
			  // The element is now the oldest in the Q = top of stack
			  while(!tempQ.isEmpty())
				  enqueue(tempQ.dequeue());
	        
	        
	        return returnElement;
		
		}
		

		
		public int dequeue(){
			
	        if(isEmpty( ))
	            return 0;
	        Qsize--;
	        int returnValue = front.value;
	        front = front.next;
	        return returnValue;
		}

		
		// MODIFIED
		// Peeks the stack end of the Q
		public int peek(){
	        if(isEmpty( ))
	            return 0;
	        
	        return back.value;
		}
		
		public int sizeIs(){
			return Qsize;
		}

		public boolean isEmpty(){
	        return front == null;
		}
	
	
		
		  // To test
		  public static void main(String[] args){
			  Qstack q = new Qstack();
			  q.enqueue(1);
			  q.enqueue(2);
			  q.enqueue(3);
			  q.enqueue(new Integer(69));
			  System.out.println(q.deStack());
			  System.out.println(q.deStack());
			  System.out.println(q.deStack());
			  System.out.println(q.deStack());

			  System.out.println(q.dequeue());
			  q.enqueue(4);
			  System.out.println(q.dequeue());
			  q.enqueue(5);
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());
			  System.out.println(q.dequeue());

		  }
		
		
		
}
