/*********************************/
/*	COMP 250	
 * 	Assigment 3
 * 
 * 	By: 
 * 	Simon Foucher
 * 	260 223 197
 * 
/*********************************/

package Question4;

public abstract class TreeOperations {
	/**
	 * Haven't gotten the algorithm to work perfectly yet...
	 * It returns true if all child of n1 have a single "twin" in n2.
	 * i.e. If every element in n1 has a is present in n2, the function
	 * returns true. Unfortunately, it fails to take into account the level
	 * of those elements, therefore fails to return false on the second case.
	 * 	
	 */
	public static boolean isIsomorphic( Node n1, Node n2)
	{
		
		// If 2 null nodes = they are isomorphic
		if (n1 == null && n2 == null)
			 return true;
		
		// If one null and the other one not null, not iso
		if (n1 == null || n2 == null) 
			return false;
		
		System.out.println("Checking: " + n1.getKey() +" and: " + n2.getKey());

		
		// If all child are null, return true
		if (n1.getLeftChild() == null && n2.getLeftChild() == null && 
					n1.getRightChild() == null && n2.getRightChild() == null) 
			return true;
	
		// If the n1's child are isomorphic with their n2's counterparts
		if (isIsomorphic(n1.getLeftChild(), n2.getLeftChild()) 
				&& isIsomorphic(n1.getRightChild(), n2.getRightChild())) 
			return true;
		
		// If the n1's child are isomorphic with their n2's opposit childs
		if (isIsomorphic(n1.getLeftChild(), n2.getRightChild()) 
				&& isIsomorphic(n1.getRightChild(), n2.getLeftChild())) 
				return true;
		
		return false;

	
	}
	
	/**
	 * Apply the level-order(breadth first) traversal method on the
	 * tree rooted at the given node, and print out the result
	 * @param r root of the tree
	 * 
	 * Note: You'll need the class QueueSLL to be part of this package
	 */
	public static void traverseTree(Node r)
	{
		// Exit if null
		if(r == null)
			return;
		
		// Create temporary node and Q
		Node temp;
		QueueSLL q = new QueueSLL();
		
		// Add root to Q
		q.enqueue(r);
		
		// Run while Q is not empty
		while(!q.isEmpty()){
			
			// Extract the first guy from the Q and print its value
			temp = (Node) q.dequeue();
			System.out.print(temp.getKey());
			
			// Look for its children and repeat operation
			if(temp.getLeftChild() != null)
				q.enqueue(temp.getLeftChild());
			
			if(temp.getRightChild() != null)
				q.enqueue(temp.getRightChild());
		}
			
	}
	
	
	
	

	
	
	
	public static void main(String[] args)
	{
		//EX1
		// tree 1
		Node root1 = new Node(5);
		// depth 1
		root1.setLeftChild( new Node(8));
		root1.setRightChild( new Node(4));
		// depth 2
		Node subRoot = root1.getLeftChild();
		subRoot.setLeftChild( new Node(2));
		subRoot.setRightChild( new Node(6));
		// depth 3
		Node temp = subRoot;
		subRoot = temp.getRightChild();
		subRoot.setLeftChild( new Node(3));
		subRoot.setRightChild( new Node(2));
		
		
		//tree 2
		Node root2 = new Node(5);
		// depth 1
		root2.setLeftChild( new Node(4));
		root2.setRightChild( new Node(8));
		// depth 2
		subRoot = root2.getRightChild();
		subRoot.setLeftChild( new Node(6));
		subRoot.setRightChild( new Node(2));
		// depth 3
		temp = subRoot;
		subRoot = temp.getLeftChild();
		subRoot.setLeftChild( new Node(3));
		subRoot.setRightChild( new Node(2));
		
		//EX2
		//Tree 3
		Node root3 = new Node(5);
		// depth 1
		root3.setLeftChild( new Node(8));
		root3.setRightChild( new Node(4));
		// depth 2
		subRoot = root3.getLeftChild();
		subRoot.setLeftChild( new Node(2));
		subRoot.setRightChild( new Node(3));
		// depth 3
		temp = subRoot;
		subRoot = temp.getRightChild();
		subRoot.setLeftChild( new Node(6));
		subRoot.setRightChild( new Node(2));
		
		// Tree 4
		Node root4 = new Node(5);
		// depth 1
		root4.setLeftChild( new Node(4));
		root4.setRightChild( new Node(8));
		// depth 2
		subRoot = root4.getRightChild();
		subRoot.setLeftChild( new Node(6));
		subRoot.setRightChild( new Node(2));
		// depth 3
		temp = subRoot;
		subRoot = temp.getLeftChild();
		subRoot.setLeftChild( new Node(3));
		subRoot.setRightChild( new Node(2));
		
		System.out.println("Tree 1:");
		traverseTree(root1);
		System.out.println("\nTree 2:");
		traverseTree(root2);
		System.out.println("\nTree 3:");
		traverseTree(root3);
		System.out.println("\nTree 4:");
		traverseTree(root4);
		System.out.println();
		
		System.out.println("Tree 1 is isomorphic to Tree 2: " + isIsomorphic(root1, root2));
		System.out.println("Tree 3 is isomorphic to Tree 4: " + isIsomorphic(root3, root4));
		
	}
	
}
